
:- calculus cKD4s5s.

% agent 1

[bel(1)]:likes(jan, coca).
[bel(1)]:likes(piotr, pepsi).

[bel(1)]: ([pos(1)]:likes(X, coca) :- likes(X, pepsi)).
[bel(1)]: ([pos(1)]:likes(X, pepsi) :- likes(X, coca)).

% agent 2

[bel(2)]:likes(jan, pepsi).
[bel(2)]:likes(piotr, coca).
[bel(2)]:likes(piotr, beer).

[bel(2)]: (likes(X, coca) :- likes(X, pepsi)).
[bel(2)]: (likes(X, pepsi) :- likes(X, coca)).

% agent 3

[bel(3)]:likes(jan, coca).
[pos(3)]:likes(piotr, pepsi).
[pos(3)]:likes(piotr, beer).

[bel(3)]: (very_much_likes(X, Y) :- 
		likes(X, Y), 
		for_all(I, [1,2], [bel(I)]:likes(X, Y))).

[bel(I)]: (for_all(Index, Range, Inst) :- 
		\+ ((member(Index, Range), \+ Inst))). 

% interface with the user: 
		
very_much_likes(X, Y) :- [bel(3)]:very_much_likes(X, Y).

likes(X, Y) :- [pos(3)]:very_much_likes(X, Y).

probably_likes(X, Y) :- [bel(I)]:likes(X, Y).

possibly_likes(X, Y) :- [pos(I)]:likes(X, Y).

/* goals to answer:

mcall(very_much_likes(X, Y), cKD4s5s).
mcall(likes(X, Y), cKD4s5s).
mcall(probably_likes(X, Y), cKD4s5s).
mcall(possibly_likes(X, Y), cKD4s5s).

*/
