
:- calculus cKDI4s5, cKDI4s, cKDI4, cKDI45. 

[bel(2)]:good_in_maths(X) :- maths_teacher(X).

[bel(3)]: ([bel(I)]:good_in_maths(X) :- [bel(I)]:mathematician(X)).

[bel(1)]: ([pos(I)]:good_in_maths(X) :- maths_student(X)).

[bel(1)]: ([pos(I)]:good_in_physics(X) :- physics_student(X)).
[bel(1)]: ([pos(2)]:good_in_maths(X) :- good_in_physics(X)).

maths_teacher(john).
[bel(2)]:mathematician(tom).
[bel(3)]:maths_student(peter).
[bel(3)]:physics_student(mike).

%----------------------------------------------------------------

:- calculus classical.

good_in_maths(Cal, X, BeliefDegree) :- 
	setof(I, mcall([bel(I)]:good_in_maths(X), Cal), L),
	max(L, BeliefDegree).

possibly_good_in_maths(Cal, X, Degree) :- 
	setof(I, mcall([pos(I)]:good_in_maths(X), Cal), L),
	min(L, Degree).

min([N|L], 1) :- var(N), !.
min([N], N) :- !.
min([N|L], Min) :- min(L, Min2), (N < Min2 -> Min = N; Min = Min2).

max([N|L], 3) :- var(N), !.
max([N], N) :- !.
max([N|L], Max) :- max(L, Max2), (N > Max2 -> Max = N; Max = Max2).


%----------------------------------------------------------------
/* goals to answer:

mcall([bel(I)]:good_in_maths(X), cKDI4s5).
mcall([pos(I)]:good_in_maths(X), cKDI4s5).

setof((X,I), good_in_maths(cKDI4s5, X, I), GoodInMaths).
setof((X,I), possibly_good_in_maths(cKDI4s5, X, I), PossiblyGoodInMaths).

mcall([bel(_),bel(I)]:good_in_maths(X), cKDI4s).
mcall([bel(_),bel(I)]:good_in_maths(X), cKDI4).

setof((X,I), good_in_maths(cKDI4s, X, I), GoodInMaths).
setof((X,I), possibly_good_in_maths(cKDI4s, X, I), PossiblyGoodInMaths).
	
setof((X,I), good_in_maths(cKDI4, X, I), GoodInMaths).
setof((X,I), possibly_good_in_maths(cKDI4, X, I), PossiblyGoodInMaths).

mcall([bel(I)]:good_in_maths(X), cKDI45).
mcall([pos(I)]:good_in_maths(X), cKDI45).

*/
